import numpy as np
import pandas as pd
from sklearn.model_selection import train_test_split
from sklearn import metrics
from sklearn import tree
import matplotlib.pyplot as plt

data = pd.read_csv('data.txt', sep=';')
temperature = data['Tin']

newlabel = []
label = data['label']
for n in range(len(label)):
    if (type(label[n])) != int:
        if float(label[n]) < 0.5:
            newlabel.append(0)
        else:
            newlabel.append(1)

data['newlabel'] = newlabel
# divide data into training and testing :

max_depth = [1, 2, 3, 4, 5, 6,]
accuracy = [0.9740, 0.974, 0.9740, 0.9610, 0.9610, 0.9610 ]
plt.plot(max_depth,accuracy)
plt.show()
def importance(x_train, y_train):
    clf = tree.DecisionTreeClassifier(random_state=0, criterion='entropy', max_depth=6)
    clf.fit(x_train, y_train)
    important = clf.feature_importances_
    return important


# implement DT
def decision_tree(x_train, y_train, x_test, y_test):
    clf = tree.DecisionTreeClassifier(max_depth=6, random_state=0, criterion='entropy')
    clf = clf.fit(x_train, y_train)
    important_feature = clf.feature_importances_
    print("features_importance=", (important_feature))
    y_test_pred = clf.predict(x_test)
    accuracy = clf.score(x_test, y_test)
    print("accuracy", accuracy)
    indices = np.argsort(important_feature)
    plt.title('features_importance')
    plt.barh(range(len(indices)), important_feature[indices], color='b', align='center')
    plt.yticks(range(len(indices)), [x_train.columns.values[i] for i in indices])
    plt.xlabel('Relative importance')
    plt.show()
    with open("tree.dot", "w") as file:
        tree.export_graphviz(clf, out_file=file)
    print(metrics.classification_report(y_test, y_test_pred, target_names=['level 0', 'level 1']))
    return (y_test_pred)


x_train, y_train, x_test, y_test = train_test_split(data[["Tin", "Tout", "humidity", "detected_motions", "power",
                                                          "office_CO2_concentration", "Door", "CO2_corridor",
                                                          "acoustic_pressure_dB"]], data[['newlabel']], test_size=.1,
                                                    random_state=0)

y_pred_occupancy = decision_tree(x_train, x_test, y_train, y_test)
x_train, x_test, y_train, y_test = [], [], [], []
for i in range(0, len(label_train)):
    Features_train = [feature1[i], feature2[i], feature3[i], feature4[i],
                      feature5[i]]
    x_train.append(features - train)
    y_train.append(label_train[I])
for i in range(0, len(label_test)):
    features_test = [feature1[i], feature2[i], feature3[i], feature4[i],
                     feature5[i]]
    x_test.append(features_test)
    y_test.append(label_test[i])
